﻿using System;
using System.Collections.Generic;
using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace WmsTest
{
    /// <summary>
    ///     Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }


        private void test()
        {
            WpfMap.MapUnit = GeographyUnit.Meter;

            WpfMap.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255));
            var layer = new ShapeFileFeatureLayer(@"ShpFiles\Cardiff_Boundary_region.shp");
            layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Black),
                new GeoSolidBrush(GeoColor.SimpleColors.Transparent));
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            var layer2 = new ShapeFileFeatureLayer(@"ShpFiles\ITN Sample.shp");
            layer2.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.ContestedBorder1;
            layer2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;


            var staticOverlay = new LayerOverlay
            {
                TransitionEffect = TransitionEffect.None,
                TileType = TileType.SingleTile
            };
            staticOverlay.Layers.Add("layer", layer);
            staticOverlay.Layers.Add("layer2", layer2);
            WpfMap.Overlays.Add(staticOverlay);


            var projection = new Proj4Projection
            {
                InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(27700),
                ExternalProjectionParametersString =
                    "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +no_defs"
                // Proj4Projection.GetBingMapParametersString()
            };
            projection.Open();
            layer2.Open();
            layer.Open();
            RectangleShape boundingBox = layer.GetBoundingBox();
            RectangleShape box2 = layer2.GetBoundingBox();
            layer.FeatureSource.Projection = projection;
            layer2.FeatureSource.Projection = projection;
            var list = new List<BaseShape> { box2};
            RectangleShape ex = ExtentHelper.GetBoundingBoxOfItems(list);
            WpfMap.CurrentExtent = projection.ConvertToExternalProjection(ex.GetBoundingBox());
            layer.Close();


            var bingMapsOverlay = new BingMapsOverlay("Au9yN0FUHyp5zAoh0zWBjbw81-eSeaiH2J_zTFiCWQ0OYlhYX9i17jR9cnBhQFLJ");
       //     WpfMap.Overlays.Insert(0, bingMapsOverlay);

            WpfMap.Refresh();
        }


        private void MainWindow_OnLoaded(object sender, RoutedEventArgs e)
        {
           
                test();
          
        }
    }
}